/*
 * battery_indication_rm.h
 *
 * This data type is defined in the same way as the &#39;BatteryIndication&#39; data type, but with the OpenAPI &#39;nullable: true&#39; property. 
 */

#ifndef _OpenAPI_battery_indication_rm_H_
#define _OpenAPI_battery_indication_rm_H_

#include <string.h>
#include "../external/cJSON.h"
#include "../include/list.h"
#include "../include/keyValuePair.h"
#include "../include/binary.h"
#include "battery_indication.h"
#include "null_value.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct OpenAPI_battery_indication_rm_s OpenAPI_battery_indication_rm_t;
typedef struct OpenAPI_battery_indication_rm_s {
    bool is_battery_ind;
    int battery_ind;
    bool is_replaceable_ind;
    int replaceable_ind;
    bool is_rechargeable_ind;
    int rechargeable_ind;
} OpenAPI_battery_indication_rm_t;

OpenAPI_battery_indication_rm_t *OpenAPI_battery_indication_rm_create(
    bool is_battery_ind,
    int battery_ind,
    bool is_replaceable_ind,
    int replaceable_ind,
    bool is_rechargeable_ind,
    int rechargeable_ind
);
void OpenAPI_battery_indication_rm_free(OpenAPI_battery_indication_rm_t *battery_indication_rm);
OpenAPI_battery_indication_rm_t *OpenAPI_battery_indication_rm_parseFromJSON(cJSON *battery_indication_rmJSON);
cJSON *OpenAPI_battery_indication_rm_convertToJSON(OpenAPI_battery_indication_rm_t *battery_indication_rm);
OpenAPI_battery_indication_rm_t *OpenAPI_battery_indication_rm_copy(OpenAPI_battery_indication_rm_t *dst, OpenAPI_battery_indication_rm_t *src);

#ifdef __cplusplus
}
#endif

#endif /* _OpenAPI_battery_indication_rm_H_ */

